<?php
// Core functions used wherever needed. Called by both page and ajax routines. 
// Fix php5.4+ timezone issue... 
@date_default_timezone_set(date_default_timezone_get());
// @date_default_timezone_set('UTC');

// For the sake of hardening, you can if you wish use a custom config directory.. 
define('configdir','sitecfg/',1);
// get site settings from ini file.. 
setsitedefaults();
getuseragent();

// Determine relative paths to content locations... 
syspaths();
session_set(cookie,siteroot);

// if debug parameter is set OR you are authenticated, log php errors to file. 
if (gets('authenticated') || get('debug')){
  ini_set('error_log', dirname(__FILE__) . '/../log/php_error.log');
  ini_set('log_errors', 1);
  error_reporting(E_ALL);
}    

// if debug is set AND you are authenticated, show ajax transactions, etc.
// Otherwise, suppress php error output to screen. 
if (gets('authenticated') && get('debug')){
  define("debug",1,1);
}else{
  ini_set('display_errors', 0);
  define("debug",0,1);
//  define("debug",1,1);
}    

// Echo paths to page if in debug mode... 
showpaths();

// Allow plugins to execute. Mainly for benefit of eXtplorer. 
if (!defined('_VALID_MOS')) define( '_VALID_MOS', 1 );

return;

function plugin($name){
  $pluginphp = siteroot . path(pluginbase) . $name . '/' . 'plugin.php' ;
  $fspluginphp = fsroot . path(pluginbase) . $name . '/' . 'plugin.php' ;
  $fspluginjs = fsroot . path(pluginbase) . $name . '/' . 'plugin.js' ;
  $pluginjs = siteroot . path(pluginbase) . $name . '/' . 'plugin.js' ;
  $fsplugincss = fsroot . path(pluginbase) . $name . '/' . 'plugin.css' ;
  $plugincss = siteroot . path(pluginbase) . $name . '/' . 'plugin.css' ;
  $pfound=false;
  if (file_exists($fsplugincss)){
    $pfound=true;
    echo "<link rel='stylesheet' href='$plugincss".jsindex."' type='text/css' >\n";
  }
  if (file_exists($fspluginjs)){
    $pfound=true;
    echo "<script type='text/javascript' src='$pluginjs".jsindex."'></script>\n";
  }
  if (file_exists($fspluginphp)){
    $pfound=true;
    return $fspluginphp;     
  }
  if ($pfound==false){
    if (debug||get('debug')) echo "<p style='color:red;'>Warning: Plugin <i>$name</i> failed to load.<p>";
  }
  return "" ;
}


function loadplugin($pluginname){
    if (strpos($pluginname,".")!==false) return false;
    if (debug && !file_exists(siteroot . $pluginname)) {
        echo "<small>[missing plugin $pluginname]</small>"; 
        return false;
    }
    $phpinclude=siteroot . pluginbase . '/' . pluginname . '/plugin.php';
    $jsinclude=siteroot . pluginbase . '/' . pluginname . '/plugin.js';
    if (file_exists($phpinclude)) include_once($phpinclude); 
    if (file_exists($jsinclude)) echo "<script src='$jsinclude'></script>";
}


function session_set($sname="hyperframe",$spath="/") {
  // Variables are by default placed in a sub-array to prevent clashes 
  // with any other software loaded. 
  $sname.="_session";
  if(session_id()=="") {
    if (!defined('SESSION_NAME')) define( 'SESSION_NAME', $sname);
    session_name(SESSION_NAME);
    $sessionCookieExpireTime=0;
    session_set_cookie_params($sessionCookieExpireTime,$spath);
    session_start();
  }
}

function setsitedefaults(){
// Read site settings from ini and put into constants. Use default if no ini value.  
// Note, we get the location relative to codebase because we don't yet have the system path info..
    $absfile=str_replace('\\','/',__FILE__);
    if (strpos($absfile,":/")==1 ) $absfile=substr($absfile,2,512);
    // Go two-up to get filesystem root of this website... 
    $fsroot= pathname($absfile,2) ;  
  $siteinifile = $fsroot . configdir . 'siteini.php' ;
  $asiteconfig=inireadarray($siteinifile) ;
  setconst($asiteconfig,'site','salt','shash','232');
  setconst($asiteconfig,'site','sitename','sitename','hyperframe');
  setconst($asiteconfig,'site','cookie','cookie',sitename);
  setconst($asiteconfig,'site','frame','default_frame','frame');
  setconst($asiteconfig,'site','pluginbase','pluginbase','plugin');
  setconst($asiteconfig,'site','imgdir','imgdir','img/'); // not implemented
  setconst($asiteconfig,'site','default_extension','default_extension','php');
  setconst($asiteconfig,'site','browser_cache','browser_cache',0);
  setconst($asiteconfig,'menu','mainmenu','mainmenu','tree.mnu');
  setconst($asiteconfig,'menu','quicklinkmenu','quicklinkmenu','quicklink.mnu');
  setconst($asiteconfig,'menu','menu_separator','menu_separator','=');
  setconst($asiteconfig,'menu','multiviews','multiviews',0);
  setconst($asiteconfig,'menu','sidemenu_autoclose','sidemenu_autoclose',0);
  setconst($asiteconfig,'menu','topmenu_timeout','topmenu_timeout',10);
  setconst($asiteconfig,'editing','add_shebang','add_shebang',1);
  setconst($asiteconfig,'editing','site_editors','site_editors',"");
  setconst($asiteconfig,'editing','site_editlevel','site_editlevel',1);
  setconst($asiteconfig,'editing','sourcecode_editlevel','sourcecode_editlevel',3);
  setconst($asiteconfig,'editing','inline_scripts','inline_scripts',4);
  setconst($asiteconfig,'editing','file_restore','file_restore',3);
  setconst($asiteconfig,'editing','admin_upload_any','admin_upload_any',0);
  setconst($asiteconfig,'security','editkey','editkey','admin');
  setconst($asiteconfig,'security','keepalive','kato_keepalive',15);
  setconst($asiteconfig,'security','timeout','kato_timeout',45);
  setconst($asiteconfig,'security','harvesting_protection','harvesting_protection','2');
  setconst($asiteconfig,'security','allowed_ips','allowed_ips','');
  setconst($asiteconfig,'security','prohibited_ips','prohibited_ips','');
//  setconst($asiteconfig,'blog','catalog_page','catalog_page','index.');

if (browser_cache) {
   define('jsindex','');
 }else{
   define('jsindex','?' . rand(1,1000));
 }
}

function setconst(&$iniarray,$section="general",$key,$constant,$default=""){
  if (isset($iniarray[$section][$key])) {
      define($constant,$iniarray[$section][$key],1);
  }else{
      define($constant,$default,1);
  }
}

function gets($value, $context="hyperframe"){
  // gets a session OR global parameter; exits gracefully if it does not exist. 
  if(session_id() != ""){ 
    if (isset($_SESSION[$context][$value])) return $_SESSION[$context][$value];
  }
    if (isset($GLOBALS[$context][$value])) return $GLOBALS[$context][$value];
  return null; 
}

function getg($value, $default=null, $context="hyperframe"){
  // gets a global parameter; exits gracefully if it does not exist. 
    if (isset($GLOBALS[$context][$value])) {
        return $GLOBALS[$context][$value];
    }else{
        return $default;
    }     
}

function sets($value,$data, $context="hyperframe"){
  // sets a global parameter; uses session if available. 
  if (session_id() != "") {
    $_SESSION[$context][$value]=$data;
  }
    $GLOBALS[$context][$value]=$data;
}

function setg($value,$data, $context="hyperframe"){
  // Sometimes we don't want a variable to span pages, in which case we always use the global array. 
    $GLOBALS[$context][$value]=$data;
}

// These next are to prevent errors being thrown -or the need for repeated isset checks- 
// when submitted data might be null, and to allow binary safe POST variables. 

function get($parameter) {
 if (isset($_GET[$parameter])):
  return $_GET[$parameter];
 else:
  return ""; 
 endif;
}

function getp($parameter,$encoded=true) {
 if (!isset($_POST[$parameter])) return "";
  $data = str_replace(' ','+',$_POST[$parameter]);
  if ($encoded)$data=base64_decode($data,true); 
  return $data;
}

function getr($parameter) {
 if (isset($_REQUEST[$parameter])):
  return $_REQUEST[$parameter];
 else:
  return ""; 
 endif;
}

// Data conversion... 

function brbr2p($page) {
  // Convert pages using <br><br> para breaks to <p> for compatibility with CKEditor.
  // No need to enter </p> tags - CK will do that on first save.
    $pattern="~(<br>|<br />)[\r\n|\n]*(<br>|<br />)~siU";
    $replacement= "\r\n<p class='brbr'>\r\n";
    $page = preg_replace($pattern, $replacement, $page);
  return $page;
}

function tagdata($html, $thistag, $simulate=false){
  $istagok = preg_match("~(<".$thistag.".*>)(.*)(</".$thistag.".*>)~siU",$html,$atagparts);
  // Allow for text pages containing no tags: 
  if (($istagok<1) and $simulate):
   $atagparts[1] = "<".$thistag.">"; 
   $atagparts[2] = $html;
   /// was callingpage. changed as throwing error on siteground. 
   $atagparts[3] = "</".$thistag.">";
  endif;
  // prevent missing closing tags from throwing errors; 
  for ($ct=0;$ct<4;$ct++) {
    if (!isset($atagparts[$ct])) $atagparts[$ct]="";
  }
return $atagparts;
}

function getmetas($contents)
{
    $result = false;
    if (isset($contents) && is_string($contents))
    {
        $title = null;
        $metaTags = null;
        preg_match_all('/<[\s]*meta[\s]*name="?' . '([^>"]*)"?[\s]*' . 'content="?([^>"]*)"?[\s]*[\/]?[\s]*>/si', $contents, $match);
        if (isset($match) && is_array($match) && count($match) == 3)
        {
            $originals = $match[0];
            $names = $match[1];
            $values = $match[2];
            if (count($originals) == count($names) && count($names) == count($values))
            {
                $metaTags = array();
                for ($i=0, $limiti=count($names); $i < $limiti; $i++)
                {
                    $metaTags[$names[$i]]['content'] =  $values[$i];
                    $metaTags[$names[$i]]['value'] =  $originals[$i];
                }
            }
        }
    }
    return $metaTags;
}


function frag($key, $thisstr, $nparts=3){
  $split=explode($key, $thisstr);
  for ($ct=0;$ct<=$nparts;$ct++) {
    if (!isset($split[$ct])) $split[$ct]="";
  }
 return $split;
}

function syspaths($mastercopy=1){

    // Should only be executed in a file in the codebase directory.
    // Can be included from anywhere.     
    // Note; pagefile is not necessarily the displayed webpage when calling from a system file!  
    
    /*
    Logistics: 
    Relative paths are used wherever possible in page content, to keep websites portable. 
    Relative paths do not start with slash. Absolute paths do. 
    For system folders, the system generates paths from the document root on the fly. 
    Directories always end with slash, whether relative or absolute. 
    */
    $rtnval="";
    
    // Strip Windows notation from this include's path, if present...
    $absfile=str_replace('\\','/',__FILE__);
    if (strpos($absfile,":/")==1 ) $absfile=substr($absfile,2,512);
    // Go two-up to get filesystem root of this website... 
    $fsroot= pathname($absfile,2) ;  
 
    // codebase gives the system folder name..  
    $syspath=explode("/", $absfile);
    // This will be the folder with the system scripts..  
    $codebase=path($syspath[count($syspath)-2]);
 
    $callingpage= $_SERVER['SCRIPT_NAME'];
    // Get the path to this webpage, as from Web root 
    // (not necessarily site root, note, as site may be in subdir of webspace)  
    $pagedir=pathname($callingpage);
    if ($pagedir=='.') $pagedir="";
    
    // Identify path from root of webspace to base folder of website. 
    // Works by comparing filesystem root with page dir, looking for contiguous set of directories. 
    // This method has to be used, because the document root variable returned by php is not always correct on shared hosting. 
    // Note that this mechanism may fail if the site has a chain of same-named subdirectories. (though this is very rare) 
    $apagedir=explode("/", $pagedir);
    $afsroot=explode("/", $fsroot);
    $pidx=0;
    $siteroot="";
    $insiteroot=false;
    foreach ($afsroot as $thisdir){
      if ($thisdir==$apagedir[$pidx]) {
        $pidx++;
        if ($thisdir=="") continue;
          $insiteroot=true;
          $siteroot = $siteroot . '/' . $thisdir;
      } else {
          if ($insiteroot) break; 
      }
    }
    $siteroot .= '/';

    $codedir=$siteroot . $codebase;
    $fsconfigdir= $fsroot . configdir ;
    $pagefile=ltrim(substr($callingpage,strlen($siteroot),255),'/');

    // vars common to all page instances;     
  if (!defined('siteroot')){
    // define ('framedir', $siteroot . frame . '/',1);
    define ('framebase','frame/');
    setg('siteroot',$siteroot);
    define('siteroot',$siteroot,1);
    setg('fsroot',$fsroot);
    define('fsroot',$fsroot,1);
    setg('codebase',$codebase);
    define('codebase',$codebase,1);
    setg('codedir',$codedir);
    define('codedir',$codedir,1);
    define('fsconfigdir',$fsconfigdir,1);
    setg('pagefile',$pagefile);
    define('pagefile',$pagefile,1);
    setg('pagedir',$pagedir);
    define('pagedir',$pagedir,1);
  }

   // Provide these vars to Javascript:
   // (To use, echo the returned string to the browser)
   $rtnval= "<script>\n";
   $rtnval.= "var siteroot='$siteroot';\n";
   $rtnval.= "var fsroot='$fsroot';\n";
   $rtnval.= "var codebase='$codebase'\n;";
   $rtnval.= "var codedir='$codedir'\n;";
   $rtnval.= "var pagefile='$pagefile';\n";
   $rtnval.= "var pagedir='$pagedir';\n";
   $rtnval.= "var imgdir='". imgdir ."';\n";
   $rtnval.= "var configdir='".configdir."';\n";
   $rtnval.= "var kato_keepalive='".kato_keepalive."';\n";
   $rtnval.= "var kato_timeout='".kato_timeout."';\n";
   $rtnval.= "var sourcecode_editlevel='".sourcecode_editlevel."';\n";
   $rtnval.= "var file_restore='".file_restore."';\n";
   $rtnval.= "var default_extension='".default_extension."';\n";
   $rtnval.= "</script>\n";
    setg('js_syspaths',$rtnval);
    @define('js_syspaths',$rtnval,1);
}


function showpaths() {
    if (debug>1) {
    echo __FILE__ . ' file<br>';
    echo siteroot . ' siteroot<br>';
    echo fsroot . ' fsroot<br>';
    echo codebase . ' codebase<br>';
    echo codedir . ' codedir<br>';
    echo $callingpage . ' callingpage<br>';
    echo pagefile . ' pagefile<br>';
    echo pagedir . ' pagedir<br>';
    echo framedir . ' framedir<br>';
    echo imgdir . ' imgdir<br>';
    }
}

function pathname($inpath,$levels=1) {
// Better filename-strip function, minus idiosyncrasies (eg null=.) and able to strip n levels from path (1=strip filename) 
$thispath=rtrim($inpath,'/');
$ct=$levels;
 while ($ct>0) {
  $ct--;
  $lastfs=strripos($thispath,"/");
  $thispath=substr($thispath,0,$lastfs);  
 }
 if ((substr($inpath,0,1)=='/') && (substr($thispath,0,1)!='/')) $thispath= '/' . $thispath;
 if ($thispath!="" && substr($thispath, -1,1)!="/") $thispath .= '/';
 return $thispath;  
}

function path($loc){
// Rationalises pathnames to always end with /
 if ($loc!="") {
   if (substr($loc, -1,1)<>"/"){
     $loc .= '/';
   }
 } 
// echo ">".$loc. "|";
 return $loc;
}

function stripext($thispath, $exts=".htm|.html|.php") {
// Removes extension from local link, for multiviews linking.
   $dotpos=strripos($thispath,"."); 
   $rtnval=$thispath;
   if ($dotpos>0){
     $ext =  substr($thispath, $dotpos);
     if (stripos($exts,$ext)!==false){
       if (strpos($ext,"/")===false){
          $rtnval = substr($thispath,0,$dotpos) ;    
       }    
     }
   }
   return $rtnval;
}

function relroot($loc){
   $nslashes=substr_count(ltrim($loc,'/'),'/'); 
   // echo $loc .$nslashes;
   $rel=str_repeat('../',$nslashes) . $loc;
   return $rel;
}

function thisfsdir($callingfile,$rtn_echo=false){
  $absfile=str_replace('\\','/',$callingfile);
  if (strpos($absfile,":/")==1 ) $absfile=substr($absfile,2,512);
  $rtn=pathname(siteroot.substr($absfile, strlen(fsroot)),1);
  if ($rtn_echo==1) echo $rtn;
  if ($rtn_echo==2) echo "var thispage='$rtn'";
  if ($rtn_echo==3) echo "<script>var thispage='$rtn'</script>";
return $rtn;
}   

function thisdir($callingpage,$rtn_echo=false){
  $rtn=pathname(siteroot.substr($callingpage, strlen(fsroot)),1);
  if ($rtn_echo==1) echo $rtn;
  if ($rtn_echo==2) echo "var thispage='$rtn'";
  if ($rtn_echo==3) echo "<script>var thispage='$rtn'</script>";
return $rtn;
}    


/*  ******** ini file handling ************  */

function inireadarray($path, $section='*') {
if (!is_array($path)) {
  if(!file_exists($path)) return false;
  $fdata=file($path,FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
} else {
  $fdata=$path;
}
   if ($fdata==null) return false; 
  $inisection="-"; $ct=0; $array="";
  foreach ($fdata as $thisline) { 
    $thisline=trim($thisline," \t");
    if ($thisline=="") continue; 
    if (substr($thisline,0,1)=="<") continue; 
    if (substr($thisline,0,1)==";") continue; 
    if (substr($thisline,0,1)=="[") {
      $inisection=trim($thisline,"[]");
      $array[$inisection]["section_name"]=$inisection;
    } else {
      $item=explode("=",$thisline);
      if (!isset($item[1])) $item[1]="";
      $ct++;
      
      if ($section=='*') {
          $array[$inisection][$item[0]]=$item[1];
      } else {
          if ($section==$inisection) $array[$item[0]]=$item[1];
      }
              
    }
   }
 return $array;
}

function iniwritearray($array, $pathname) {
  if (!is_array($array)) return false; 
  $writestring=""; $inisection="-"; 
  if (pathinfo($pathname,PATHINFO_EXTENSION)=='php') $writestring.="<?php exit ?>\n; This file is system generated. Hand editing is not advised.\n";
  foreach ($array as $inisection=>$inisectionval) { 
    if (isset($array[$inisection]['is_deleted'])) continue; 
    if ($inisection!='-') $writestring.="[".$inisection."]\n";  
    foreach ($inisectionval as $item=>$value) { 
      $writestring.="$item=$value\n";
    }
  } 
   if (!$handle = fopen($pathname, 'w')) { 
        return false; 
    } 
    if (!fwrite($handle, $writestring)) { 
        return false; 
    } 
    fclose($handle); 
    return true; 
  }


/*  ********* Menu Code *********** */
// include_once(plugin('menu'));


function ipcheck(){
$ip=clientip();
$ipn=ip2long($ip);
$ipok=255;

if (strlen(allowed_ips)>0){
  $ipok=0;
  if (trim(allowed_ips)=="*") {
      $ipok=3;
  }else{
    $aallowed=explode(",",allowed_ips);
    foreach ($aallowed as $thisrange) {
      if (strpos($ip,$thisrange)===0) $ipok=2;
      if (debug>2 )echo "IP: $thisrange :  $ipok<br>";
    }
  }
}
if (strlen(prohibited_ips)>0){
  if (trim(prohibited_ips)=="*") {
      $ipok=0;
  }else{
    $aprohibited=explode(",",prohibited_ips);
    foreach ($aprohibited as $thisrange) {
      if (strpos($ip,$thisrange)!==false) $ipok=0;
      if (debug>2 )echo "Prohibited_IP: $thisrange :  $ipok<br>";
    }
  }
}

// if (filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE) !== true) $ipok=1;

  if ($ipok==0){
   // nonsense error message to confuse foreign intruder..    
   die ('Parameter must be numeric, not string. Invalid function call in /libs/pear/loader.php, line 3423.');
  }
 if (get('debug')>2) echo "Client IP is: " . $ip . " " . $ipn. " " . $ipok;
}

function clientip() {
    foreach (array('HTTP_CLIENT_IP', 'HTTP_X_FORWARDED_FOR', 'HTTP_X_FORWARDED', 'HTTP_X_CLUSTER_CLIENT_IP', 'HTTP_FORWARDED_FOR', 'HTTP_FORWARDED', 'REMOTE_ADDR') as $key)
    {
        if (array_key_exists($key, $_SERVER) === true)
        {
            foreach (array_map('trim', explode(',', $_SERVER[$key])) as $ip)
            {
                if (filter_var($ip, FILTER_VALIDATE_IP) !== false)
                {
                    return $ip;
                }
            }
        }
    }
}

function widgets(){
  framemenu();
  printbutton();
}

function framemenu() {
   // creates expanding list of frames.. 
   $out= "<button type='button' id='framebutton' class='widget' title='Show available styling frames' onClick='showFrameSelector(true);'>
   <img src='".codedir."img/view.png' alt='+'></button>" ;
   $out.='<div id=\'framemenu\' onClick=\'showFrameSelector(false)\' title=\'Select a frame to view this site in. The frame determines the layout and styling of this website. The choice will apply to all pages until you close the browser or leave the site for a while. The active frame is '. frame .'. \'>';

   $out.= "<span><button type='button' class='widget' title='Close list, no change' onClick='showFrameSelector(false);'>
   <img src='".codedir."img/view.png' alt='+'></button>" ;

   $dcontents = scandir(fsroot.framebase);
   natsort($dcontents);
   $numframes=0;
   foreach ($dcontents as $thisitem) {
     if(substr($thisitem,0,1)==".") continue;
     $thisclass = (stristr($thisitem, frame)!==false) ? "class='active_frame' " : "" ;
     if (!is_dir(fsroot.framebase.$thisitem)) continue;
     $out.="<a href='".siteroot.pagefile."?frame=". $thisitem ."' $thisclass>" . ucwords($thisitem) . "</a>";
     $numframes++;
   }
   $out.='</span></div>';
   if ($numframes>1) echo $out;
}


// retained as sep. function for backward compatibility..
function printbutton($icon="print.gif"){
   echo '<a href="'. siteroot . pagefile .'?style=print" title="Print page content" target="printout" class="widget"><img src="'. framedir . 'menu_img/'. $icon .'" border=0></a>';
}    


function getuseragent($agent=null) {
  // Return the name and version of the client browser 
  $known = array('msie', 'firefox', 'safari', 'webkit', 'opera', 'netscape',
    'konqueror', 'gecko', 'seamonkey', 'iron', 'chrome');
  $agent = strtolower($agent ? $agent : $_SERVER['HTTP_USER_AGENT']);
  $pattern = '#(?P<browser>' . join('|', $known) .
    ')[/ ]+(?P<version>[0-9]+(?:\.[0-9]+)?)#';
  if (!preg_match_all($pattern, $agent, $matches)) return array();
  $i = count($matches['browser'])-1;
//  echo $matches['browser'][$i];
  setg('browser_name',$matches['browser'][$i]);
  $thisversion=$matches['version'][$i];
  if ($thisversion=='') $thisversion='unknown';
  setg('browser_version',$thisversion);  
//  echo getg('browser_version');
}


function multicolumn($thesecontainers="div.multicolumn",$columns=2,$spacing='10px') {
// echo getg('browser_name') .'|'. getg('browser_version')  ;
  if (getg('browser_name')=="msie" ){ 
   if (getg('browser_version')>8) {
    echo <<<EOF
    <style>
    $thesecontainers {
      column-count:$columns;
      column-gap:$spacing;
      -moz-column-count:$columns; 
      -webkit-column-count:$columns; 
      -moz-column-gap:$spacing; 
      -webkit-column-gap:$spacing; 
    } 
    </style>
EOF;
   }else{
     echo "<br><i><sub>Please note: Your browser is too old to display this page in multi-column format.</sub></i>";
   }
  }else{
   echo <<<EOF
   <style>
   $thesecontainers {
    -moz-column-count:$columns; 
    -webkit-column-count:$columns; 
    -moz-column-gap:$spacing; 
    -webkit-column-gap:$spacing; 
   } 
   </style>
EOF;
  }
}

function remove_shebang($pagedata){
   $pagedata=preg_replace('~^<\?php\s*?include_once.*?codebase/hyperframe\.php.*?\s*\?>\s*~si','',$pagedata,1);
   return $pagedata;
}

function hf_truncate($string, $limit) {
    // Limits length of string to maxchars, trimming back to last whole word
    // $string = strip_tags($string); //Strip HTML tags off the text
    // $string = html_entity_decode($string); //Convert HTML special chars into normal text
    $string = str_replace(array("\r", "\n"), "", $string); //Also cut line breaks
    if(mb_strlen($string, "UTF-8") <= $limit) return $string; //If input string's length is no more than cut length, return untouched
    $last_space = mb_strrpos(mb_substr($string, 0, $limit, "UTF-8"), " ", 0, "UTF-8"); //Find the last space symbol position
    return mb_substr($string, 0, $last_space, "UTF-8").' ...'; //Return the string's length substracted till the last space and add three points
}


?>
