<?php include_once 'codebase/hyperframe.php' ?><h1>Troubleshooting your install</h1>

<p><strong>Existing files:</strong></p>

<p>A .htaccess file and php.ini file are supplied in the distribution. It may be advisable to check if same-named files&nbsp;already exist on the server, and whether over-writing them would cause any issues.</p>

<h4>Server returns a &#39;500 Error&#39; instead of displaying index.php</h4>

<p>This usually indicates that there is a line in the .htaccess file which the server cannot understand. It might also indicate that a setting is present in .htaccess or php.ini which the hosting company has disallowed. &nbsp;</p>

<p><i>If your php implementation is the CGI variety and the &#39;php_value auto_prepend_file&#39; .htaccess line is activated, you will most definitely get this message.</i> The fix is to add # to disable this line.</p>

<h4>Server returns &#39;PHP Fatal error:&nbsp; Unknown: Failed opening required codebase/hyperframe.php&#39;</h4>

<p>The respective line in php.ini or .htaccess refers to an incorrect location, or the file is missing. This might also arise if the permissions on the codebase directory are incorrect.</p>

<h4>Page loads in browser, but with no banner or menu</h4>

<p>Ensure that you are viewing the site through the webserver, and not by opening the pages directly from the zip. Regardless of the CMS used, no php site can be viewed directly from its files. The other reason this may happen is if the Hyperframe system is not being launched, and what you are seeing is the bare page content. It may be that the server&#39;s php setup is configured to disallow prepending, or that the php version is too old. Or, the page may be missing the &#39;shebang&#39; (reflex loader command) in its first line.</p>

<p><strong>A yellow &#39;Frame missing&#39; message appears, followed by the plain page content. </strong></p>

<p>This indicates that either some files are missing from the frame, or&nbsp; that the reference to the frame in siteini.php is pointing to an incorrect location. Version 4 differs from earlier releases in that frames are in their own subdirectories, so the actual &#39;frame/&#39; directory no longer contains a frame.</p>

<h4>Page loads OK but login doesn&#39;t work or Hyperbar never appears</h4>

<p>The user (page editing) login relies on a session cookie being set by the browser. If your browser is set to refuse cookies, this may be the problem.&nbsp; Some Web filtering software or proxies may also cause problems with online editing. In that case, see if an exclusion can be set. Most modern browsers will be able to load the editing interface, although Firefox is recommended.&nbsp; See the Requirements page for more info on this aspect.</p>

<p>&nbsp;</p>
